#include "rca.h"


void
loop_wait(uint32_t num){
    volatile uint32_t loop;
    for(loop = 0; loop < (num*100); loop++){
        Asm("nop");
    }
}

/*
 *  For MAINTASK
 */ 
void setup() {
    Serial.begin(115200);
    Serial.println("setup() : running");
}

void loop() {
    Serial.println("loop() : running");
    loop_wait(10000);
}

/*
 *  For TASK1
 */
void task1_setup() {
    pinMode(13, OUTPUT);
    dis_dsp();
    Serial.println("task1_setup() : running");
    ena_dsp();
}

void task1_loop() {
    digitalWrite(13, HIGH);
    loop_wait(10000);
    digitalWrite(13, LOW); 
    loop_wait(10000);
}

/*
 *  For TASK2
 */
void task2_setup() {
    dis_dsp();
    Serial.println("task2_setup() : running");
    ena_dsp();
    SerialUSB.begin(115200);
    while(!SerialUSB){ ; }
    SerialUSB.println("task2_setup() : running");
}

void task2_loop() {
    SerialUSB.println("task2loop() : running");
    loop_wait(10000);
}

/*
 *  For TASK3
 */
void task3_setup() {
    dis_dsp();
    Serial.println("task3_setup() : running");
    ena_dsp();    
}

void task3_loop() {
    Serial.println("task3loop() : running");
    loop_wait(20000);
}

/*
 *  For TASK4
 */
void task4_setup() {
    dis_dsp();
    Serial.println("task4_setup() : running");
    ena_dsp();
}

void task4_loop() {
    Serial.println("task4loop() : running");
    loop_wait(40000);
}

